      program gen_knot    

      implicit none

      real*8, allocatable :: U_KNOT(:), V_KNOT(:),W_KNOT(:)
      real*8, allocatable :: UN_KNOT(:), VN_KNOT(:),WN_KNOT(:)      
      integer NSD,P,Q,R,MCP,NCP,OCP
      real*8  ksu,ksv,ksw
      integer neu,nev,new
      integer aneu,anev,anew
      real*8  x,y
      integer meshf,knotfile,elems
      integer flg,i,j,ku,kv,kw,prt

      real*8   length,du
      
      
      integer , allocatable ::  partu(:),partv(:),partw(:)
 


      character*10 inp
c
c...  Read in preliminary information
c

      open (meshf, file='geom.dat', status='old')
      write (*,*)   "Generating knot span"
      read (meshf,*)  NSD           ! number of spatial dimensions
      write (*,*)     NSD           ! number of spatial dimensions      
      read (meshf,*)  P, Q, R       ! degree of curves in u, v, and w direction
      write (*,*)     P, Q, R       ! degree of curves in u, v, and w direction      
      read (meshf,*)  MCP, NCP, OCP ! number of control points in each direction
      write (*,*)     MCP, NCP, OCP ! number of control points in each direction


c
c...  Allocate arrays for knot vectors 
c
      allocate(U_KNOT(MCP+P+1))    
      allocate(V_KNOT(NCP+Q+1))
      allocate(W_KNOT(OCP+R+1))

c
c...  Read knot vectors and control net
c
      do i = 1,MCP+P+1
         if (i < MCP+P+1) then
            read (meshf,"(F13.9)", ADVANCE = "NO") U_KNOT(i) ! read U_KNOT
         else
            read (meshf,"(F13.9)", ADVANCE = "YES") U_KNOT(i) 
         endif
      enddo

      do i = 1,NCP+Q+1
         if (i < NCP+Q+1) then
            read (meshf,"(F13.9)", ADVANCE = "NO") V_KNOT(i) ! read V_KNOT
         else
            read (meshf,"(F13.9)", ADVANCE = "YES") V_KNOT(i) 
         endif
      enddo

      do i = 1,OCP+R+1
         if (i < OCP+R+1) then
            read (meshf,"(F13.9)", ADVANCE = "NO") W_KNOT(i) ! read W_KNOT
         else
            read (meshf,"(F13.9)", ADVANCE = "YES") W_KNOT(i) 
         endif
      enddo

c
c...  Get size of knot span
c

      call IArgC(i)
      if (i.ne.3) then  
        call getarg(1,inp); read(inp,*) neu
        call getarg(2,inp); read(inp,*) nev
        call getarg(3,inp); read(inp,*) new
      else
c
c...  Get number of elements
c
        write(*,*)"Elements in u direction? "
        read(*,*) neu
        write(*,*)"Elements in v direction? " 
        read(*,*) nev
        write(*,*)"Elements in w direction? "
        read(*,*) new 
      endif


      ksu=U_KNOT(MCP+R+1) - U_KNOT(1)
      ksv=V_KNOT(NCP+R+1) - V_KNOT(1)
      ksw=W_KNOT(OCP+R+1) - W_KNOT(1)
      
      aneu = neu - (MCP - P)
      anev = nev - (NCP - Q)
      anew = new - (OCP - R)


c 
c...  Allocate arrays for knot vectors 
c





      do prt = Q +1, NCP -1     
	length = V_KNOT(prt+1) - V_KNOT(prt)      
        elems = int(5d-1+(real(nev)*length/ksv))
        du = length/real(elems) 
        write(*,*)  (5d-1+real(nev)*length/ksv),elems      	
      enddo 






c 
c...  Allocate arrays for knot vectors 
c














      allocate(UN_KNOT(aneu))
      allocate(VN_KNOT(anev))
      allocate(WN_KNOT(anew))


      ku=0    
      write(*,*)  "U"      
      do prt = P +1, MCP -1     
	length = U_KNOT(prt+1) - U_KNOT(prt)      
        elems = int(5d-1+real(neu)*length/ksu)
        du = length/real(elems) 
        write(*,*)   elems
        do i = 1,elems-1
	   ku = ku + 1
	   UN_KNOT(ku) = U_KNOT(prt) + real(i)*du
        enddo	
      enddo 
      prt=MCP     
      length = U_KNOT(prt+1) - U_KNOT(prt)      
      elems = aneu - ku+1
      du = length/real(elems) 
        write(*,*)   elems      
      do i = 1,elems-1
        ku = ku + 1
        UN_KNOT(ku) = U_KNOT(prt) + real(i)*du
      enddo	      
      
      
      kv=0   
      write(*,*)  "V"           
      do prt = Q +1, NCP -1     
	length = V_KNOT(prt+1) - V_KNOT(prt)      
        elems = int(5d-1+real(nev)*length/ksv)
        du = length/real(elems) 
        write(*,*)   elems      
        do i = 1,elems-1
	   kv = kv + 1
	   VN_KNOT(kv) = V_KNOT(prt) + real(i)*du
        enddo	
      enddo 
      prt=NCP     
      length = V_KNOT(prt+1) - V_KNOT(prt)      
      elems = anev - kv+1
      du = length/real(elems) 
         write(*,*)   elems     
      do i = 1,elems-1
        kv = kv + 1
        VN_KNOT(kv) = V_KNOT(prt) + real(i)*du
      enddo
      
      kw=0      
      write(*,*)  "W"
      do prt = R+1, OCP -1     
	length = W_KNOT(prt+1) - W_KNOT(prt)      
        elems = int(5d-1+real(new)*length/ksw)
        du = length/real(elems) 
             write(*,*)   elems 
        do i = 1,elems-1
	   kw = kw + 1
	   WN_KNOT(kw) = W_KNOT(prt) + real(i)*du
        enddo	
      enddo 
      prt=OCP     
      length = W_KNOT(prt+1) - W_KNOT(prt)      
      elems = anew - kw+1
      du = length/real(elems) 
            write(*,*)   elems  
      do i = 1,elems-1
        kw = kw + 1
        WN_KNOT(kw) = W_KNOT(prt) + real(i)*du
      enddo
      
c
c...  Read in preliminary information
c
      knotfile = 12
      open  (knotfile, file='knot.dat', status='unknown')
      if (neu == 0) then
        write (knotfile,"(I5)", ADVANCE = "NO")  0
      else
        write (knotfile,"(I5)", ADVANCE = "NO")  1
      endif
      if (nev == 0) then
        write (knotfile,"(I5)", ADVANCE = "NO")  0
      else
        write (knotfile,"(I5)", ADVANCE = "NO")  1
      endif
      
      if (new == 0) then
        write (knotfile,"(I5)", ADVANCE = "YES")  0
      else
        write (knotfile,"(I5)", ADVANCE = "YES")  1
      endif  
      
      write (knotfile,"(I5)", ADVANCE = "NO")  ku 
      write (knotfile,"(I5)", ADVANCE = "NO")  kv
      write (knotfile,"(I5)", ADVANCE = "YES") kw 
        
c
c...  Write knot vectors and control net
c
      do i = 1,ku
         if (i < ku) then
            write (knotfile,"(F13.9)", ADVANCE = "NO")  UN_KNOT(i) 
         else
            write (knotfile,"(F13.9)", ADVANCE = "YES") UN_KNOT(i)  
         endif
      enddo

      do i = 1,kv
         if (i < kv) then
            write (knotfile,"(F13.9)", ADVANCE = "NO")  VN_KNOT(i) 
         else
            write (knotfile,"(F13.9)", ADVANCE = "YES") VN_KNOT(i)     
         endif
      enddo

      do i = 1,kw
         if (i < kw) then
            write (knotfile,"(F13.9)", ADVANCE = "NO")  WN_KNOT(i) 
         else
            write (knotfile,"(F13.9)", ADVANCE = "YES") WN_KNOT(i)    
         endif
      enddo

      end
      


