      program gen_annulus

      implicit none

      integer meshf
      real*8 h(2), r(2), w
      real*8 knot(2), x1(4), x2(4), sign1(4),sign2(4), y1(4), y2(4)
      integer i,j,k,count,q
                 
      character*10 inp   
      character*10 cname
      character*30 fname
c...  Read geo values
      call getarg(1,inp); read(inp,*) r(1)
      call getarg(2,inp); read(inp,*) r(2)
      call getarg(3,inp); read(inp,*) h(2)

c...  Initialize
      h(1)=0d0
      w=dsqrt(2d0)/2d0
      knot(1)=-0.25d0
      knot(2)=0d0
      x1(1:4) = (/ 1, 0, -1, 0 /)
      x2(1:4) = (/ 0, 1, 0, -1 /)
      sign1(1:4) = (/ 1, -1, -1, 1 /)
      sign2(1:4) = (/ 1, 1, -1, -1 /)
      y1(1:4) = (/ 0, -1, 0, 1 /)
      y2(1:4) = (/ 1, 0, -1, 0 /)

c...  Loop through the four meshes (rotated quarter of annulus)
      do q = 1, 4
         knot(:)=knot(:)+0.25d0
!        Open file      
         meshf = 99
         fname = trim("annulus"//cname(q))//".dat"
         if (q.eq.1) then
            fname = trim("annulus"//".dat")
         endif
         open (meshf, file=fname, status='unknown')      
!        Write Header
         write (meshf,*) 3 
         write (meshf,*) 2,1,1 
         write (meshf,*) 3,2,2 
!        Knots
         write (meshf,"(F13.9)", ADVANCE = "NO" ) knot(1)
         write (meshf,"(F13.9)", ADVANCE = "NO" ) knot(1)
         write (meshf,"(F13.9)", ADVANCE = "NO" ) knot(1)
         write (meshf,"(F13.9)", ADVANCE = "NO" ) knot(2)
         write (meshf,"(F13.9)", ADVANCE = "NO" ) knot(2)
         write (meshf,"(F13.9)", ADVANCE = "YES") knot(2)
         do i = 1,2
            write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0
            write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0  
            write (meshf,"(F13.9)", ADVANCE = "NO" ) 1.0d0 
            write (meshf,"(F13.9)", ADVANCE = "YES") 1.0d0 
         enddo
!        Controle points 
         do k = 1, 2
            do j = 1, 2
               write (meshf,"(F13.9)", ADVANCE = "NO" ) r(j)*x1(q)
               write (meshf,"(F13.9)", ADVANCE = "NO" ) r(j)*x2(q)
               write (meshf,"(F13.9)", ADVANCE = "NO" ) h(k)
               write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
               
               write (meshf,"(F13.9)", ADVANCE = "NO" ) r(j)*sign1(q)
               write (meshf,"(F13.9)", ADVANCE = "NO" ) r(j)*sign2(q)
               write (meshf,"(F13.9)", ADVANCE = "NO" ) h(k)
               write (meshf,"(F13.9)", ADVANCE = "YES") w
               
               write (meshf,"(F13.9)", ADVANCE = "NO" ) r(j)*y1(q)
               write (meshf,"(F13.9)", ADVANCE = "NO" ) r(j)*y2(q)
               write (meshf,"(F13.9)", ADVANCE = "NO" ) h(k)
               write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
            enddo
         enddo
!        Controle points
         do k = 1,2   
            do j = 1,2
               do i = 1,2
                  count = count + 1
                  write(meshf,"(I5)") count		
               enddo
            enddo
         enddo

         close(meshf)
      enddo








100   format(F13.9,F13.9,F13.9,F13.9)
      end



!=======================================================================
!                      General routines
!=======================================================================

      function cname (i)

      logical      beg
      character*10 cname,cc
      integer      il(0:8)

      integer i, ic0, ii, k

      ic0 = ICHAR("0")
      cc = " "
      ii = i

      il(0) = mod(ii,10)
      do k = 1,8
        ii = (ii - il(k-1)) / 10
        il(k) = mod (ii,10)
      enddo

      beg = .false.

      do k = 8,1,-1
        if (il(k) .ne. 0 .or. beg) then
          beg = .true.
          cc  = TRIM(cc) // CHAR(ic0 + il(k))
        endif
      enddo

      cc = TRIM(cc)//CHAR(ic0 + il(0))
      cname = "." // cc

      return
      end
