      program gen_cylinder

      implicit none

      integer meshf
      real*8 r, h(2)
      integer i,j,k,count
                 
      character*10 inp   

 
      call getarg(1,inp); read(inp,*) r
      call getarg(2,inp); read(inp,*) h(2)
      h(1)=0d0
      
      meshf = 99
      open (meshf, file='cylinder.dat', status='unknown')      

!  Write Header
      write (meshf,*) 3 
      write (meshf,*) 2,2,1 
      write (meshf,*) 9,3,2 
      
!  Knots
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0  
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.25d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.25d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.5d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.5d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.75d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.75d0  
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1.0d0  
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1.0d0  
      write (meshf,"(F13.9)", ADVANCE = "YES") 1.0d0

      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0  
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0  
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1.0d0 
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1.0d0 
      write (meshf,"(F13.9)", ADVANCE = "YES") 1.0d0
 
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0  
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1.0d0 
      write (meshf,"(F13.9)", ADVANCE = "YES") 1.0d0 
      
! Controle points 
      do i = 1,2
         ! Inner ring
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
         
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
    
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
   
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

         ! Intermediate ring
         write (meshf,"(F13.9)", ADVANCE = "NO" ) r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) -r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) -r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) -r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) -r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) -r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) -r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) r/2d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
         
         ! Outer ring
         write (meshf,"(F13.9)", ADVANCE = "NO" ) r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) -r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) -r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) -r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) -r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) -r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) -r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

         write (meshf,"(F13.9)", ADVANCE = "NO" ) r
         write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
         write (meshf,"(F13.9)", ADVANCE = "NO" ) h(i)
         write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
      enddo

! Controle points
      do k = 1,2   
        do j = 1,2
          do i = 1,2
	    count = count + 1
            write(meshf,"(I5)") count		
          enddo
        enddo
      enddo

      close(meshf)

100   format(F13.9,F13.9,F13.9,F13.9)
      end
