      subroutine input(dir, k, knot, order)  

      implicit none  

      integer dir, k , order
      real*8  knot(1024)

      real*8, allocatable :: U_KNOT(:), V_KNOT(:),W_KNOT(:)
      integer NSD,P,Q,R,MCP,NCP,OCP 
      
      integer meshf
      integer i,j
      character*10 inp
c
c...  Read in preliminary information
c
      meshf = 11
      open (meshf, file='mesh.dat', status='old')
      
      read (meshf,*)  NSD           ! number of spatial dimensions
      read (meshf,*)  P, Q, R       ! degree of curves in u, v, and w direction
      read (meshf,*)  MCP, NCP, OCP ! number of control points in each direction

c
c...  Allocate arrays for knot vectors 
c
      allocate(U_KNOT(MCP+P+1))    
      allocate(V_KNOT(NCP+Q+1))
      allocate(W_KNOT(OCP+R+1))

c
c...  Read knot vectors 
c
      do i = 1,MCP+P+1
         if (i < MCP+P+1) then
            read (meshf,"(F13.9)", ADVANCE = "NO" ) U_KNOT(i) ! read U_KNOT
         else
            read (meshf,"(F13.9)", ADVANCE = "YES") U_KNOT(i) 
         endif
      enddo
      write (*,*) "Finished reading U knot"
      do i = 1,NCP+Q+1
         if (i < NCP+Q+1) then
            read (meshf,"(F13.9)", ADVANCE = "NO" ) V_KNOT(i) ! read V_KNOT
         else
            read (meshf,"(F13.9)", ADVANCE = "YES") V_KNOT(i) 
         endif
      enddo
      write (*,*) "Finished reading V knot"
      do i = 1,OCP+R+1
         if (i < OCP+R+1) then
            read (meshf,"(F13.9)", ADVANCE = "NO" ) W_KNOT(i) ! read W_KNOT
         else
            read (meshf,"(F13.9)", ADVANCE = "YES") W_KNOT(i) 
         endif
      enddo
      write (*,*) "Finished reading W knot"


c
c...  Assign correct knot
c
      if (dir == 1) then
        order = P
        k = MCP+P+1	
	knot(1:k) = U_KNOT
      else if (dir == 2) then
        order = Q      
        k = NCP+Q+1
	knot(1:k) = V_KNOT		
      else if (dir == 3) then
        order = R
        k = OCP+R+1	
	knot(1:k) = W_KNOT			
      endif  
      
      deallocate(U_KNOT)
      deallocate(V_KNOT)
      deallocate(W_KNOT)


      end subroutine
      


