      program gen_prostate

      implicit none

      integer meshf, readf
      integer i,j,k,count,version, nlines
                 
      character*10 inp
      character*300 fname
      character*10000 line
      character*10 cname
      
      integer IREC, ISRC, IDST, IERR
      character*1 CHAR
      
      integer l
      integer NSD, P, Q, R, MCP, NCP, OCP
      real*8, allocatable :: U_KNOT(:), V_KNOT(:),W_KNOT(:)
      real*8, allocatable :: B_NET(:,:,:,:)
      
c...  Read arguments
      call getarg(1,inp); read(inp,*) version
      fname='../../automesh/gen_prostate/prostate' //
     &     trim(cname(version)) // '.dat'

c...  Count lines
      !File to read from
      readf= 98
      open (readf, file=trim(fname), status='unknown')
      !Count lines
      nlines=0
      do
         read (readf,*, END=10)
         nlines=nlines+1
      enddo
      !Close
 10   close(readf)

c...  Copy to file
      meshf = 99
      if (version.lt.12) then
         open (meshf, file='prostate.dat', status='unknown')
      else
         open (meshf, file='delete.dat', status='unknown')
      endif
      open (readf, file=trim(fname), status='unknown')
      do i=1,nlines
         read(readf,'(A)')line
         write(meshf,'(A)')trim(line)
      enddo

c...  Close
      close(readf)
      close(meshf)


c...  Read
      !Read in preliminary information
      readf= 65
      open (readf, file='delete.dat', status='unknown')
      read (readf,*)  NSD           ! number of spatial dimensions
      read (readf,*)  P, Q, R       ! degree of curves in u, v, and w direction
      read (readf,*)  MCP, NCP, OCP ! number of control points in each direction

      !Allocate arrays for knot vectors and for control net
      allocate(U_KNOT(MCP+P+1))    
      allocate(V_KNOT(NCP+Q+1))
      allocate(W_KNOT(OCP+R+1))
      allocate(B_NET(MCP,NCP,OCP,NSD+1))

      !Read knot vectors
      do i = 1,MCP+P+1
         if (i < MCP+P+1) then
            read (readf,"(F13.9)", ADVANCE = "NO") U_KNOT(i) ! read U_KNOT
         else
            read (readf,"(F13.9)", ADVANCE = "YES") U_KNOT(i) 
         endif
      enddo
      do i = 1,NCP+Q+1
         if (i < NCP+Q+1) then
            read (readf,"(F13.9)", ADVANCE = "NO") V_KNOT(i) ! read V_KNOT
         else
            read (readf,"(F13.9)", ADVANCE = "YES") V_KNOT(i) 
         endif
      enddo
      do i = 1,OCP+R+1
         if (i < OCP+R+1) then
            read (readf,"(F13.9)", ADVANCE = "NO") W_KNOT(i) ! read W_KNOT
         else
            read (readf,"(F13.9)", ADVANCE = "YES") W_KNOT(i) 
         endif
      enddo

      !Read control net
      do k = 1,(OCP)
         do j = 1,(NCP)
            do i = 1,(MCP)
               do l = 1,NSD+1
                  if (l.eq.1) then
                     read (readf,"(F16.9)", ADVANCE = "NO")
     &                    B_NET(i,j,k,l)
                  elseif (l.eq.2) then
                     read (readf,"(F16.9)", ADVANCE = "NO")
     &                    B_NET(i,j,k,l)
                  elseif (l.eq.3) then
                     read (readf,"(F16.9)", ADVANCE = "NO")
     &                    B_NET(i,j,k,l)
                  else
                     read (readf,"(F16.9)", ADVANCE = "YES") 
     &                    B_NET(i,j,k,l)
                  endif
               enddo
            enddo
         enddo
      enddo

      !Read control net - Jessica
c      do k = 1,(OCP)
c        do j = 1,(NCP)
c            do i = 1,(MCP)
c               do l = 1,NSD+1
c                  if (l.eq.1) then
c                     read (readf,"(F14.9)", ADVANCE = "NO")
c     &                    B_NET(i,j,k,l)
c                  elseif (l.eq.2) then
c                     read (readf,"(F13.9)", ADVANCE = "NO")
c     &                    B_NET(i,j,k,l)
c                  elseif (l.eq.3) then
c                     read (readf,"(F14.9)", ADVANCE = "NO")
c     &                    B_NET(i,j,k,l)
c                  else
c                     read (readf,"(F13.9)", ADVANCE = "YES")
c     &                    B_NET(i,j,k,l)
c                  endif
c               enddo
c            enddo
c         enddo
c      enddo

c...  Close
      close(readf)

c...  Write
      if (version.ge.12) then
         !Open
         meshf=34
         open (meshf, file='prostate.dat', status='unknown')
         !Preliminary info
         write (meshf,*)  NSD   ! number of spatial dimensions
         write (meshf,"(I2)", ADVANCE = "NO") Q
         write (meshf,"(I2)", ADVANCE = "NO") R ! degree of curves in u, v, and w direction
         write (meshf,"(I2)", ADVANCE = "YES") P
         write (meshf,"(I3)", ADVANCE = "NO") NCP
         write (meshf,"(I3)", ADVANCE = "NO") OCP ! number of control points in each direction
         write (meshf,"(I4)", ADVANCE = "YES") MCP
         
         write(*,*) NCP, OCP, MCP


         !Write knot vectors
         do i = 1,NCP+Q+1
            if (i < NCP+Q+1) then
               write (meshf,"(F13.9)", ADVANCE = "NO") V_KNOT(i) ! write V_KNOT
            else
               write (meshf,"(F13.9)", ADVANCE = "YES") V_KNOT(i) 
            endif
         enddo
         do i = 1,OCP+R+1
            if (i < OCP+R+1) then
               write (meshf,"(F13.9)", ADVANCE = "NO") W_KNOT(i) ! write W_KNOT
            else
               write (meshf,"(F13.9)", ADVANCE = "YES") W_KNOT(i) 
            endif
         enddo
         do i = 1,MCP+P+1
            if (i < MCP+P+1) then
               write (meshf,"(F13.9)", ADVANCE = "NO") U_KNOT(i) ! write U_KNOT
            else
               write (meshf,"(F13.9)", ADVANCE = "YES") U_KNOT(i) 
            endif
         enddo

         !Write control net
         do i = 1,(MCP)
            do k = 1,(OCP)
               do j = 1,(NCP)
                  do l = 1,NSD+1
                     if (l.eq.1) then
                        write (meshf,"(F16.9)", ADVANCE = "NO")
     &                       B_NET(i,j,k,l)
                     elseif (l.eq.2) then
                        write (meshf,"(F16.9)", ADVANCE = "NO")
     &                       B_NET(i,j,k,l)
                     elseif (l.eq.3) then
                        write (meshf,"(F16.9)", ADVANCE = "NO")
     &                       B_NET(i,j,k,l)
                     else
                        write (meshf,"(F16.9)", ADVANCE = "YES") 
     &                       B_NET(i,j,k,l)
                     endif
                  enddo
               enddo
            enddo
         enddo

        !Write control net -- Jessica
c         do i = 1,(MCP)
c            do k = 1,(OCP)
c               do j = 1,(NCP)
c                  do l = 1,NSD+1
c                     if (l.eq.1) then
c                        write (meshf,"(F14.9)", ADVANCE = "NO")
c     &                       B_NET(i,j,k,l)
c                     elseif (l.eq.2) then
c                        write (meshf,"(F13.9)", ADVANCE = "NO")
c     &                       B_NET(i,j,k,l)
c                     elseif (l.eq.3) then
c                        write (meshf,"(F14.9)", ADVANCE = "NO")
c     &                       B_NET(i,j,k,l)
c                     else
c                       write (meshf,"(F13.9)", ADVANCE = "YES")
c     &                       B_NET(i,j,k,l)
c                     endif
c                  enddo
c               enddo
c            enddo
c         enddo

      endif


c...  Close
      close(meshf)



      end


!#############################################################################
      function cname (i)

      logical      beg
      character*10 cname,cc
      integer      il(0:8)

      integer i, ic0, ii, k

      ic0 = ICHAR("0")
      cc = " "
      ii = i

      il(0) = mod(ii,10)
      do k = 1,8
        ii = (ii - il(k-1)) / 10
        il(k) = mod (ii,10)
      enddo

      beg = .false.

      do k = 8,1,-1
        if (il(k) .ne. 0 .or. beg) then
          beg = .true.
          cc  = TRIM(cc) // CHAR(ic0 + il(k))
        endif
      enddo

      cc = TRIM(cc)//CHAR(ic0 + il(0))
      cname = "." // cc

      return
      end
