c     This routine links each face in an h-refined mesh with its parent face
c        in the unrefined mesh.
c
c     FACE_CON(i) = j indicates that element j in the OLD mesh is the parent
c        of element i in the new mesh.
c
c     modified for user specified knot insertion June 25, 2004
c
c       Feb. 10, 2004
c       J. Austin Cottrell
c       CAM Graduate Student
c       Institute for Computational Engineering Science
c       The University of Texas at Austin     

      subroutine gen_FACE_CON_3D(FACE_CON,new_NFACE,new_MCP,new_NCP,
     &  new_OCP,uflag,vflag,wflag)

      use aAdjKeep
      include "common.h"
      
      integer e, icount,i,j,jcount,new_MCP,new_NCP,new_NFACE
      integer  FACE_CON(new_NFACE), new_OCP,kcount,k,uflag,vflag,wflag
      
      

c     Each face orientation must be treated separately, though the basic
c       behaviour of each loop is the same. Note that uflag = 1 indicates
c       that we have inserted knots into U_KNOT. Likewise with vflag and
c       wflag.      

      e = 0    
      if (CLOSED_W_flag.ne.1) then
c...    Loop through orientation 1
        
        jcount = 0
        do j= 1,NCP-Q
          icount = 0
          do i = 1,MCP-P
            e = e+1
            FACE_CON(i+icount + (new_MCP-P)*(j-1+jcount)) = e
            if (((icount+1).le.(new_MCP-MCP)).and.
     &        ((U_KNOT(i+P).le.x_knot_u(icount+1)).and.
     &        (x_knot_u(icount+1).lt.U_KNOT(i+P+1))).and.
     &        (uflag.eq.1)) then
 1000         continue
              icount = icount+1
              FACE_CON(i+icount + (new_MCP-P)*(j-1+jcount)) = e
              if ((icount+1).le.(new_MCP-MCP).and.((U_KNOT(i+P).le.
     &          x_knot_u(icount+1)).and.
     &          (x_knot_u(icount+1).lt.U_KNOT(i+P+1)))) then
                goto 1000
              endif
            endif
          enddo
          if (((jcount+1).le.(new_NCP-NCP)).and.
     &      ((V_KNOT(j+Q).le.(x_knot_v(jcount+1))).and.
     &      (x_knot_v(jcount+1)).lt.V_KNOT(j+1+Q)).and.
     &      (vflag.eq.1)) then
 1100       continue
            jcount = jcount+1
            icount = 0
            e = (j-1)*(MCP-P)
            do i = 1,MCP-P
              e = e+1
              FACE_CON(i+icount + (new_MCP-P)*(j-1+jcount)) = e
              if (((icount+1).le.(new_MCP-MCP)).and.
     &          ((U_KNOT(i+P).le.x_knot_u(icount+1)).and.
     &          (x_knot_u(icount+1).lt.U_KNOT(i+P+1))).and.
     &          (uflag.eq.1)) then
 1200           continue
                icount = icount+1
                FACE_CON(i+icount + (new_MCP-P)*(j-1+jcount)) = e
                if ((icount+1).le.(new_MCP-MCP).and.((U_KNOT(i+P).le.
     &            x_knot_u(icount+1)).and.
     &            (x_knot_u(icount+1).lt.U_KNOT(i+P+1)))) then
                  goto 1200
                endif
              endif
            enddo
            if (((jcount+1).le.(new_NCP-NCP)).and.((V_KNOT(j+Q).le.
     &        (x_knot_v(jcount+1))).and.
     &        (x_knot_v(jcount+1)).lt.V_KNOT(j+1+Q)))  then
              goto 1100
            endif
          endif
        enddo
      endif
      
      
      
      
      if (CLOSED_V_flag.ne.1) then
c...    Loop Through orientation 2
        
        kcount = 0
        do k= 1,OCP-R
          icount = 0
          do i = 1,MCP-P
            e = e+1
            FACE_CON(i+icount +
     &        (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &        (k-1+kcount)*(new_MCP-P)) = e
            if (((icount+1).le.(new_MCP-MCP)).and.
     &        ((U_KNOT(i+P).le.x_knot_u(icount+1)).and.
     &        (x_knot_u(icount+1).lt.U_KNOT(i+P+1))).and.
     &        (uflag.eq.1)) then
 2000         continue              
              icount = icount+1
              FACE_CON(i+icount +
     &          (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &          (k-1+kcount)*(new_MCP-P)) = e
              if ((icount+1).le.(new_MCP-MCP).and.((U_KNOT(i+P).le.
     &          x_knot_u(icount+1)).and.
     &          (x_knot_u(icount+1).lt.U_KNOT(i+P+1)))) then
                goto 2000
              endif
            endif
          enddo
          if (((kcount+1).le.(new_OCP-OCP)).and.
     &      ((W_KNOT(k+R).le.x_knot_w(kcount+1)).and.
     &      (x_knot_w(kcount+1).lt.W_KNOT(k+1+R))).and.
     &      (wflag.eq.1)) then
 2100       continue
            kcount = kcount+1
            icount = 0
            e = (k-1)*(MCP-P)+(1-CLOSED_W_flag)*(MCP-P)*(NCP-Q)
            do i = 1,MCP-P
              e = e+1
              FACE_CON(i+icount +
     &          (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &          (k-1+kcount)*(new_MCP-P)) = e
              if (((icount+1).le.(new_MCP-MCP)).and.
     &          ((U_KNOT(i+P).le.x_knot_u(icount+1)).and.
     &          (x_knot_u(icount+1).lt.U_KNOT(i+P+1))).and.
     &          (uflag.eq.1)) then
 2200           continue              
                icount = icount+1
                FACE_CON(i+icount +
     &            (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &            (k-1+kcount)*(new_MCP-P)) = e
                if ((icount+1).le.(new_MCP-MCP).and.((U_KNOT(i+P).le.
     &            x_knot_u(icount+1)).and.
     &            (x_knot_u(icount+1).lt.U_KNOT(i+P+1)))) then
                  goto 2200
                endif
              endif
            enddo
            if (((kcount+1).le.(new_OCP-OCP)).and.((W_KNOT(k+R).le.
     &        (x_knot_w(kcount+1))).and.
     &        (x_knot_w(kcount+1)).lt.W_KNOT(k+1+R)))  then
              goto 2100
            endif
          endif
        enddo
      endif
      
      
   
      
      
      if (CLOSED_U_flag.ne.1) then
c...    Loop Through orientation 3
        
        kcount = 0
        do k= 1,OCP-R
          jcount = 0            
          do j = 1,NCP-Q
            e = e+1
            FACE_CON(j+jcount +
     &        (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &        (1-CLOSED_V_flag)*(new_MCP-p)*(new_OCP-R)+
     &        (k-1+kcount)*(new_NCP-Q)) = e
            if (((jcount+1).le.(new_NCP-NCP)).and.
     &        ((V_KNOT(j+Q).le.(x_knot_v(jcount+1))).and.
     &        (x_knot_v(jcount+1)).lt.V_KNOT(j+1+Q)).and.
     &        (vflag.eq.1)) then
 3000         continue
              jcount = jcount+1
              FACE_CON(j+jcount +
     &          (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &          (1-CLOSED_V_flag)*(new_MCP-p)*(new_OCP-R)+
     &          (k-1+kcount)*(new_NCP-Q)) = e
              if (((jcount+1).le.(new_NCP-NCP)).and.((V_KNOT(j+Q).le.
     &          (x_knot_v(jcount+1))).and.
     &          (x_knot_v(jcount+1)).lt.V_KNOT(j+1+Q)))  then
                goto 3000
              endif  
            endif
          enddo
          if (((kcount+1).le.(new_OCP-OCP)).and.
     &      ((W_KNOT(k+R).le.x_knot_w(kcount+1)).and.
     &      (x_knot_w(kcount+1).lt.W_KNOT(k+1+R))).and.
     &      (wflag.eq.1)) then
 3100       continue
            kcount = kcount+1
            jcount = 0
            e = (k-1)*(NCP-Q)+(1-CLOSED_W_flag)*(MCP-P)*(NCP-Q)+
     &        (1-CLOSED_V_flag)*(MCP-P)*(OCP-R)
            do j = 1,NCP-Q
              e = e+1
              FACE_CON(j+jcount +
     &          (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &          (1-CLOSED_V_flag)*(new_MCP-p)*(new_OCP-R)+
     &          (k-1+kcount)*(new_NCP-Q)) = e
              if (((jcount+1).le.(new_NCP-NCP)).and.
     &          ((V_KNOT(j+Q).le.(x_knot_v(jcount+1))).and.
     &          (x_knot_v(jcount+1)).lt.V_KNOT(j+1+Q)).and.
     &          (vflag.eq.1)) then
 3200           continue
                jcount = jcount+1
                FACE_CON(j+jcount +
     &            (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &            (1-CLOSED_V_flag)*(new_MCP-p)*(new_OCP-R)+
     &            (k-1+kcount)*(new_NCP-Q)) = e
                if (((jcount+1).le.(new_NCP-NCP)).and.((V_KNOT(j+Q).le.
     &            (x_knot_v(jcount+1))).and.
     &            (x_knot_v(jcount+1)).lt.V_KNOT(j+1+Q)))  then
                  goto 3200
                endif  
              endif
            enddo
            if (((kcount+1).le.(new_OCP-OCP)).and.((W_KNOT(k+R).le.
     &        (x_knot_w(kcount+1))).and.
     &        (x_knot_w(kcount+1)).lt.W_KNOT(k+1+R)))  then
              goto 3100
            endif
          endif
        enddo
      endif
      


      
      if (CLOSED_V_flag.ne.1) then
c...    Loop Through orientation 4
        
        kcount = 0
        do k= 1,OCP-R
          icount = 0
          do i = 1,MCP-P
            e = e+1
            FACE_CON(i+icount +
     &        (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &        (1-CLOSED_V_flag)*(new_MCP-P)*(new_OCP-R)+
     &        (1-CLOSED_U_flag)*(new_NCP-Q)*(new_OCP-R)+
     &        (k-1+kcount)*(new_MCP-P)) = e
            if (((icount+1).le.(new_MCP-MCP)).and.
     &        ((U_KNOT(MCP+1-i).le.x_knot_u(new_MCP-MCP-icount)).and.
     &        (x_knot_u(new_MCP-MCP-icount).lt.U_KNOT(MCP+2-i))).and.
     &        (uflag.eq.1)) then
 4000         continue
              icount = icount+1
              FACE_CON(i+icount +
     &          (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &          (1-CLOSED_V_flag)*(new_MCP-P)*(new_OCP-R)+
     &          (1-CLOSED_U_flag)*(new_NCP-Q)*(new_OCP-R)+
     &          (k-1+kcount)*(new_MCP-P)) = e
              if ((icount.lt.(new_MCP-MCP)).and.
     &          ((U_KNOT(MCP+1-i).le.x_knot_u(new_MCP-MCP-icount)).and.
     &        (x_knot_u(new_MCP-MCP-icount).lt.U_KNOT(MCP+2-i)))) then
                goto 4000
              endif
            endif
          enddo
          if (((kcount+1).le.(new_OCP-OCP)).and.
     &      ((W_KNOT(k+R).le.x_knot_w(kcount+1)).and.
     &      (x_knot_w(kcount+1).lt.W_KNOT(k+1+R))).and.
     &      (wflag.eq.1)) then
 4100       continue
            kcount = kcount+1
            icount = 0
            e = (k-1)*(MCP-P)+(1-CLOSED_W_flag)*(MCP-P)*(NCP-Q)+
     &        (1-CLOSED_V_flag)*(MCP-P)*(OCP-R)+
     &        (1-CLOSED_U_flag)*(NCP-Q)*(OCP-R)
            do i = 1,MCP-P
              e = e+1
              FACE_CON(i+icount +
     &          (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &          (1-CLOSED_V_flag)*(new_MCP-P)*(new_OCP-R)+
     &          (1-CLOSED_U_flag)*(new_NCP-Q)*(new_OCP-R)+
     &          (k-1+kcount)*(new_MCP-P)) = e
              if (((icount+1).le.(new_MCP-MCP)).and.
     &          ((U_KNOT(MCP+1-i).le.
     &          x_knot_u(new_MCP-MCP-icount)).and.
     &          (x_knot_u(new_MCP-MCP-icount).lt.U_KNOT(MCP+2-i))).and.
     &          (uflag.eq.1)) then
 4200           continue
                icount = icount+1
                FACE_CON(i+icount +
     &            (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &            (1-CLOSED_V_flag)*(new_MCP-P)*(new_OCP-R)+
     &            (1-CLOSED_U_flag)*(new_NCP-Q)*(new_OCP-R)+
     &            (k-1+kcount)*(new_MCP-P)) = e
                if ((icount.lt.(new_MCP-MCP)).and.
     &            ((U_KNOT(MCP+1-i).le.
     &            x_knot_u(new_MCP-MCP-icount)).and.
     &            (x_knot_u(new_MCP-MCP-icount).lt.
     &            U_KNOT(MCP+2-i)))) then
                  goto 4200
                endif
              endif
            enddo
            if (((kcount+1).le.(new_OCP-OCP)).and.((W_KNOT(k+R).le.
     &        (x_knot_w(kcount+1))).and.
     &        (x_knot_w(kcount+1)).lt.W_KNOT(k+1+R)))  then
              goto 4100
            endif
          endif
        enddo
      endif
      
      

      
      if (CLOSED_U_flag.ne.1) then
c...    Loop Through orientation 5
        
        kcount = 0
        do k= 1,OCP-R
          jcount = 0            
          do j = 1,NCP-Q
            e = e+1
            FACE_CON(j+jcount +
     &        (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &        2*(1-CLOSED_V_flag)*(new_MCP-P)*(new_OCP-R)+
     &        (1-CLOSED_U_flag)*(new_NCP-Q)*(new_OCP-R)+
     &        (k-1+kcount)*(new_NCP-Q)) = e
            if (((jcount+1).le.(new_NCP-NCP)).and.
     &        ((V_KNOT(NCP+1-j).le.x_knot_v(new_NCP-NCP-jcount)).and.
     &        (x_knot_v(new_NCP-NCP-jcount).lt.V_KNOT(NCP+2-j))).and.
     &        (vflag.eq.1)) then
 5000         continue
              jcount = jcount+1
              FACE_CON(j+jcount +
     &          (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &          2*(1-CLOSED_V_flag)*(new_MCP-p)*(new_OCP-R)+
     &          (1-CLOSED_U_flag)*(new_NCP-Q)*(new_OCP-R)+
     &          (k-1+kcount)*(new_NCP-Q)) = e
              if ((jcount.lt.(new_NCP-NCP)).and.
     &          ((V_KNOT(NCP+1-j).le.x_knot_v(new_NCP-NCP-jcount)).and.
     &          (x_knot_v(new_NCP-NCP-jcount).lt.V_KNOT(NCP+2-j)))) then
                goto 5000
              endif
            endif
          enddo
          if (((kcount+1).le.(new_OCP-OCP)).and.
     &      ((W_KNOT(k+R).le.x_knot_w(kcount+1)).and.
     &      (x_knot_w(kcount+1).lt.W_KNOT(k+1+R))).and.
     &      (wflag.eq.1)) then
 5100       continue
            kcount = kcount+1
            jcount = 0
            e = (k-1)*(NCP-Q)+(1-CLOSED_W_flag)*(MCP-P)*(NCP-Q)+
     &        2*(1-CLOSED_V_flag)*(MCP-P)*(OCP-R)+
     &        (1-CLOSED_U_flag)*(NCP-Q)*(OCP-R)
            do j = 1,NCP-Q
              e = e+1
              FACE_CON(j+jcount +
     &          (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &          2*(1-CLOSED_V_flag)*(new_MCP-P)*(new_OCP-R)+
     &          (1-CLOSED_U_flag)*(new_NCP-Q)*(new_OCP-R)+
     &          (k-1+kcount)*(new_NCP-Q)) = e

              
              if ((jcount.lt.(new_NCP-NCP)).and.((vflag.eq.1).and.
     &          ((V_KNOT(NCP+1-j).le.
     &          x_knot_v(new_NCP-NCP-jcount)).and.
     &          (x_knot_v(new_NCP-NCP-jcount).lt.V_KNOT(NCP+2-j)))))
     &          then
 5200           continue
                jcount = jcount+1
                FACE_CON(j+jcount +
     &            (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &            2*(1-CLOSED_V_flag)*(new_MCP-p)*(new_OCP-R)+
     &            (1-CLOSED_U_flag)*(new_NCP-Q)*(new_OCP-R)+
     &            (k-1+kcount)*(new_NCP-Q)) = e
                if ((jcount.lt.(new_NCP-NCP)).and.
     &            ((V_KNOT(NCP+1-j).le.
     &            x_knot_v(new_NCP-NCP-jcount)).and.
     &            (x_knot_v(new_NCP-NCP-jcount).lt.
     &            V_KNOT(NCP+2-j)))) then
                  goto 5200
                endif
              endif
            enddo
            if (((kcount+1).le.(new_OCP-OCP)).and.((W_KNOT(k+R).le.
     &        (x_knot_w(kcount+1))).and.
     &        (x_knot_w(kcount+1)).lt.W_KNOT(k+1+R)))  then
              goto 5100
            endif
          endif
        enddo
      endif


      
      if (CLOSED_W_flag.ne.1) then
c...    Loop through orientation 6
        
        jcount = 0
        do j= 1,NCP-Q
          icount = 0
          do i = 1,MCP-P
            e = e+1
            FACE_CON(i+icount +
     &        (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &        2*(1-CLOSED_U_flag)*(new_NCP-Q)*(new_OCP-R) +
     &        2*(1-CLOSED_V_flag)*(new_MCP-P)*(new_OCP-R) +
     &        (new_MCP-P)*(j-1+jcount)) = e
            if (((icount+1).le.(new_MCP-MCP)).and.
     &        ((U_KNOT(i+P).le.x_knot_u(icount+1)).and.
     &        (x_knot_u(icount+1).lt.U_KNOT(i+P+1))).and.
     &        (uflag.eq.1)) then     
 6000         continue
              icount = icount+1
              FACE_CON(i+icount +
     &          (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &          2*(1-CLOSED_U_flag)*(new_NCP-Q)*(new_OCP-R) +
     &          2*(1-CLOSED_V_flag)*(new_MCP-P)*(new_OCP-R) +
     &          (new_MCP-P)*(j-1+jcount)) = e
              if ((icount+1).le.(new_MCP-MCP).and.((U_KNOT(i+P).le.
     &          x_knot_u(icount+1)).and.
     &          (x_knot_u(icount+1).lt.U_KNOT(i+P+1)))) then
                goto 6000
              endif    
            endif
          enddo
          if (((jcount+1).le.(new_NCP-NCP)).and.
     &      ((V_KNOT(j+Q).le.(x_knot_v(jcount+1))).and.
     &      (x_knot_v(jcount+1)).lt.V_KNOT(j+1+Q)).and.
     &      (vflag.eq.1)) then
 6100       continue
            jcount = jcount+1
            icount = 0
            e = (1-CLOSED_W_flag)*(MCP-P)*(NCP-Q)+
     &        2*(1-CLOSED_U_flag)*(NCP-Q)*(OCP-R) +
     &        2*(1-CLOSED_V_flag)*(MCP-P)*(OCP-R) +
     &        (MCP-P)*(j-1)
            do i = 1,MCP-P
              e = e+1
              FACE_CON(i+icount +
     &          (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &          2*(1-CLOSED_U_flag)*(new_NCP-Q)*(new_OCP-R) +
     &          2*(1-CLOSED_V_flag)*(new_MCP-P)*(new_OCP-R) +
     &          (new_MCP-P)*(j-1+jcount)) = e
              if (((icount+1).le.(new_MCP-MCP)).and.
     &          ((U_KNOT(i+P).le.x_knot_u(icount+1)).and.
     &          (x_knot_u(icount+1).lt.U_KNOT(i+P+1))).and.
     &          (uflag.eq.1)) then     
 6200           continue
                icount = icount+1
                FACE_CON(i+icount +
     &            (1-CLOSED_W_flag)*(new_MCP-P)*(new_NCP-Q)+
     &            2*(1-CLOSED_U_flag)*(new_NCP-Q)*(new_OCP-R) +
     &            2*(1-CLOSED_V_flag)*(new_MCP-P)*(new_OCP-R) +
     &            (new_MCP-P)*(j-1+jcount)) = e
                if ((icount+1).le.(new_MCP-MCP).and.((U_KNOT(i+P).le.
     &            x_knot_u(icount+1)).and.
     &            (x_knot_u(icount+1).lt.U_KNOT(i+P+1)))) then
                  goto 6200
                endif    
              endif
            enddo
            if (((jcount+1).le.(new_NCP-NCP)).and.((V_KNOT(j+Q).le.
     &        (x_knot_v(jcount+1))).and.
     &        (x_knot_v(jcount+1)).lt.V_KNOT(j+1+Q)))  then
              goto 6100
            endif
          endif
        enddo
      endif
      
      

      
      
      return
      end
