c       This subroutine generates the new_IEN matrix relating element numbers
c       and local node numbers to the appropriate global node numbers. The
c       routine also generates the new_INN matrix, which relates global node
c       number to the "NURBS coordinates" of the node. This routine is for
c       the 3D code. It is just like genIEN_INN_3D.f but for the new mesh.
c
c       genIEN_INN_3D.f written Nov 15, 2003
c
c       adapted for h-refinement
c       Feb 9, 2004
c
c       J. Austin Cottrell
c       CAM Graduate Student
c       Institute for Computational Engineering Science
c       The University of Texas at Austin
	
	subroutine gen_new_IEN_INN_3D(new_MCP, new_NCP, new_OCP,  
     &      new_IEN,new_INN,new_NEL,new_NNODZ)


	use aAdjKeep		! this f90 module contains all allocatables
c       
	include "common.h"	! common file defines all variables
c       
c...    Local variables
	integer :: i, j, k, loop1,loop2,loop3,g, e, gtemp, ln,
     &       new_MCP,new_NCP,new_OCP,new_NEL,new_NNODZ,
     &       new_IEN(new_NEL,(P+1)*(Q+1)*(R+1)), new_INN(new_NNODZ,NSD)



c       
c...    Initialize matrices and variables
c       
	new_IEN = 0
	new_INN = 0
        g = 0
        e = 0

c       
c...    Loop through control points assigning global node
c       numbers and filling out new_IEN and new_INN as we go
        do k = 1,new_OCP            ! loop through control points in W direction
	   do j = 1,new_NCP		! loop through control points in V direction
	      do i = 1,new_MCP	! loop through control points in U direction
		 g = g+1
		 new_INN(g,1) = i
		 new_INN(g,2) = j
		 new_INN(g,3) = k
		 if (((i .ge. (P+1)).and.(j .ge. (Q+1))).and.
     &                (k.ge.(R+1))) then
		    e = e +1
		    do loop1 = 0,r
		       do loop2 = 0,q
			  do loop3 = 0,p
			     gtemp = g - loop1*new_MCP*new_NCP
     &         -new_MCP*loop2-loop3
			     ln = (P+1)*(Q+1)*loop1+(P+1)*loop2 + 
     &                  	  loop3 + 1
			     new_IEN(e,ln) = gtemp
			  enddo
		       enddo
		    enddo
		 endif
	      enddo
	   enddo
	enddo	      
	   
	return
	end
	
