c     This routine links each element in the h-refined mesh with its
c        parent element in the unrefined mesh.
c
c     EL_CON(i) = j implies that element j of the OLD mesh is the parent
c           of element i in the new mesh.      
c     
c       Feb. 10, 2004
c       modified for patch splitting July 5, 2004 - jac3
c   
c       J. Austin Cottrell
c       CAM Graduate Student
c       Institute for Computational Engineering Science
c       The University of Texas at Austin

      subroutine gen_EL_CON_3D_mp(EL_CON_1,EL_CON_2,new_NEL_1,
     &  new_NEL_2,rift_span,multiplicity,dir)

      use aAdjKeep
      include "common.h"

      integer e,new_NEL_1,new_nel_2,i,j,k,rift_span
      integer  EL_CON_1(new_NEL_1), EL_CON_2(new_NEL_2),multiplicity,
     &  dir
      

      
      EL_CON_1 = 0
      EL_CON_2 = 0
      e = 0
      
c...  Splitting in U

      if (dir.eq.1) then
        
        do k = 1,OCP-R
          do j = 1,NCP-Q
            e = (MCP-P)*(NCP-Q)*(k-1)+(MCP-P)*(j-1)
            do i = 1,rift_span-multiplicity-P
              e = e+1
              EL_CON_1(i+(j-1)*(rift_span-multiplicity-P)+
     &          (k-1)*(rift_span-multiplicity-P)*(NCP-Q)) = e
            enddo
            e = (MCP-P)*(NCP-Q)*(k-1)+(MCP-P)*(j-1)+rift_span-P-1
            do i = 1,MCP-rift_span+1
              e = e+1
              EL_CON_2(i+(j-1)*(MCP-rift_span+1)+
     &          (k-1)*(MCP-rift_span+1)*(NCP-Q)) = e
            enddo
          enddo
        enddo
      endif


    
c...  Splitting in V

      if (dir.eq.2) then
        
        do k = 1,OCP-R
          do j = 1,rift_span-multiplicity-Q
            e = (MCP-P)*(NCP-Q)*(k-1)+(MCP-P)*(j-1)
            do i = 1,MCP-P
              e = e+1
              EL_CON_1(i+(j-1)*(MCP-P)+(k-1)*(MCP-P)*
     &          (rift_span-multiplicity-Q)) = e
            enddo
          enddo
          
          do j = 1,NCP-rift_span+1
            e = (MCP-P)*(NCP-Q)*(k-1)+(MCP-P)*(rift_span-Q-2+j)
            do i = 1,MCP-P
              e = e+1
              EL_CON_2(i+(j-1)*(MCP-P)+(k-1)*(MCP-P)*
     &          (NCP-rift_span+1)) = e
            enddo
          enddo
        enddo
      endif



      
c...  Splitting in W
      
      if (dir.eq.3) then
        
        do k = 1,rift_span-multiplicity-R
          e = (MCP-P)*(NCP-Q)*(k-1)
          do j = 1,NCP-Q
            do i = 1,MCP-P
              e = e+1
              EL_CON_1(i+(j-1)*(MCP-P)+(k-1)*(MCP-P)*
     &          (NCP-Q)) = e
            enddo
          enddo
        enddo

        do k = 1,OCP-rift_span+1
          e = (MCP-P)*(NCP-Q)*(rift_span-R-2+k)
          do j = 1,NCP-Q
            do i = 1,MCP-P
              e = e+1
              EL_CON_2(i+(j-1)*(MCP-P)+(k-1)*(MCP-P)*
     &          (NCP-Q)) = e
            enddo
          enddo
        enddo

          
      endif
      
      return
      end
