c...  modified to 3D January 21, 2004
c     J. Austin Cottrell


      subroutine e3Strss_3D(e, yl, shg,shgradg, lambda, mu, icount)

      use aAdjKeep
      
      include "common.h"

      real*8 lambda, mu, yl(NSHL,NSD), shg(NSHL),
     &     shgradg(NSHL,NSD), Strn(6), xl(NSD), disp(NSD)

      integer aa, bb, icount, e


      Strn = 0d+0
      xl = 0d+0
      disp = 0d+0

c...  Calculate Symmetric Strain Tensor - 2D

      do aa = 1, NSHL
         
         Strn(1) = Strn(1) + yl(aa,1)*shgradg(aa,1)
         Strn(2) = Strn(2) + yl(aa,2)*shgradg(aa,2)
         Strn(3) = Strn(3) + yl(aa,3)*shgradg(aa,3)

         Strn(4) = Strn(4) + yl(aa,1)*shgradg(aa,2) +
     &        yl(aa,2)*shgradg(aa,1)                      ! xy  - strain
         Strn(5) = Strn(5) + yl(aa,2)*shgradg(aa,3) + 
     &        yl(aa,3)*shgradg(aa,2)                      ! yz  - strain
         Strn(6) = Strn(6) + yl(aa,1)*shgradg(aa,3) + 
     &        yl(aa,3)*shgradg(aa,1)                      ! zx  - strain

c... Store displacements as well
         disp(1) = disp(1) + yl(aa,1)*shg(aa)
         disp(2) = disp(2) + yl(aa,2)*shg(aa)
         disp(2) = disp(3) + yl(aa,3)*shg(aa)
         
c... Lastly, store locations in reference configuration 
         xl(1) = xl(1) + 
     &        shg(aa)*B_NET(INN(IEN(e,aa),1), INN(IEN(e,aa),2),
     &        INN(IEN(e,aa),3),1)
         xl(2) = xl(2) +
     &        shg(aa)*B_NET(INN(IEN(e,aa),1), INN(IEN(e,aa),2),
     &        INN(IEN(e,aa),3),2)
         xl(3) = xl(3) +
     &        shg(aa)*B_NET(INN(IEN(e,aa),1), INN(IEN(e,aa),2), 
     &        INN(IEN(e,aa),3),3)

      enddo
      

c...  Format of the Elmstress is:
c...  for each integration point (indexed by icount) we have 
c...  {S11,S22,S33,S12,S23,S31,dx,dy,dz,x,y,z}

      ElmStrss(icount,1) = (lambda+2d+0*mu)*Strn(1) +
     &     lambda*Strn(2) + lambda*Strn(3)
      ElmStrss(icount,2) = (lambda+2d+0*mu)*Strn(2) +
     &     lambda*Strn(1) + lambda*Strn(3)
      ElmStrss(icount,3) = (lambda+2d+0*mu)*Strn(3) +
     &     lambda*Strn(1) + lambda*Strn(2)
      ElmStrss(icount,4) = 2d+0*mu*Strn(4)
      ElmStrss(icount,5) = 2d+0*mu*Strn(5)
      ElmStrss(icount,6) = 2d+0*mu*Strn(6)

      ElmStrss(icount,7) = disp(1)  ! x- displacement
      ElmStrss(icount,8) = disp(2)  ! y- displacement
      ElmStrss(icount,9) = disp(3)  ! z- displacement

      ElmStrss(icount,10) = xl(1)   ! x- coord
      ElmStrss(icount,11) = xl(2)   ! y- coord
      ElmStrss(icount,12) = xl(3)   ! z- coord

      return
      end

      
