      subroutine form_ek(nelist,ndiag,nnodev,nodesv,nodofv,nodelv,
c     &                   nblist,nboundary,nbcdof,nbcglo,
     &                   xmassv,xlaplv,ek)
      implicit none

c.... ................................................................
c.... Author : SP
c.... ................................................................
c.... This subroutine assembles the stiffness matrix for the 
c.... Navier-Stokes equations, using element by element matrices.
c.... ==> SKYLINE
c.... ................................................................
c.... Variable Description:
c....
c.... ................................................................

c.... List of common blocks.
      include '../common/param.blk'

c.... Input variables.
      integer nelist(0:NEMAX)
      integer ndiag( NEQMAX )
      integer nnodev,nodesv( NKVMAX, NDMAX, NEMAX ),nodofv( NEMAX )
      integer nodelv(NKVMAX,NEMAX)
      double precision xmassv( NKVMAX, NKVMAX, NEMAX )
      double precision xlaplv( NKVMAX, NKVMAX, NEMAX )
c      integer nblist(0:NBMAX), nboundary(3,NBMAX)
c      integer nbcdof(NBMAX), nbcglo(NDEGMAX+1,NBMAX)

c.... Output variables.
      double precision ek(*)

c.... Local variables.
      integer ne,nnv,nmv,neqs
      integer i,j,ni,nj,nd,nn,nb,nli,nlj

c.... ................................................................
c.... Initialize matrix
c.... ................................................................
      neqs = nnodev*ndimf
      nn   = ndiag(neqs)
      do 5 i=1,nn
         ek(i) = 0.d0
 5       continue

c.... ................................................................
c.... Start loop over elements
c.... ................................................................
      ne = nelist(0)
      do 10 while ( ne .ne. 0 )

         nnv = nodofv(ne)
         nmv = nnv*ndimf

      do 30 nd=1,ndimf
      do 30 j=1,nnv
         nlj = nodelv(j,ne)
         nj  = nodesv(j,nd,ne)

      do 30 i=1,nnv
         nli = nodelv(i,ne)
         ni  = nodesv(i,nd,ne)
         if ( ni .le. nj ) then
            nn = ndiag(nj) - ( nj - ni )
            ek(nn) = ek(nn) + C * xmassv(nli,nlj,ne) 
            ek(nn) = ek(nn) + xlaplv(nli,nlj,ne)
            endif
 30      continue

         ne = nelist(ne)
 10      continue
      
c ...
c ... Boundary conditions are imposed afterwards in the subroutin apply_bc.
c ... by changing the matrix and the rhs.
c ...

cc.... ................................................................
cc.... Dirichlet boundary conditions
cc.... ................................................................
c      nb = nblist(0)
c      do 200 while ( nb .ne. 0 )
c         ne  = nboundary(1,nb)
c         nnv = nbcdof(nb)
c
c         do 210 nd=1,ndimf
c         do 210 i=1,nnv
c            ni = nbcglo(i,nb)
c            ni = nodesv(ni,nd,ne)
c            nn = ndiag(ni)
c            ek(nn) = 1.d8 
c  210    continue
c
c         nb = nblist(nb)
c 200     continue

      return
      end
c.... ................................................................
c.... END-OF-FILE: ../pack_equa/form_ek.f
c.... ................................................................
