C...  modified for 3D on January 21, 2004
c     J. Austin Cottrell

      subroutine StrssRet_3D
      
      
      use aAdjKeep
      
      include "common.h"
      
      
c...  Local variables
      integer e, igauss, jgauss, i, icount, j, k, kgauss
      integer row(NNODZ*NNODZ),col(NNODZ+1),ni,nj,nk,strss_file
      real*8 shl(NSHL), shg(NSHL), shgradl(NSHL,NSD),
     &     shgradg(NSHL,NSD)
      real*8 gp(NGAUSS), gw(NGAUSS), skl(2,2,NSD)
      real*8 lambda, numod, Emod, mu, yl(NSHL,NSD)
      

      allocate(ElmStrss(NEL_NZA*NGAUSS*NGAUSS*NGAUSS,12))

      strss_file = 13
      open (strss_file, file='stress_3D.dat', status='unknown')


c     get Gaussian points and weights
      
      gp = 0d+0
      gw = 0d+0
      icount = 0
      
     
      call genGPandGW(gp,gw)
      
      
c...  loop over knot spans in w
      do nk = R+1,OCP

         if (W_KNOT(nk).ne.W_KNOT(nk+1)) then


c...  loop over points in w direction
            do kgauss = 1, NGAUSS

c...  loop over knot spans in v
               do nj = Q+1,NCP


                  if (V_KNOT(nj).ne.V_KNOT(nj+1)) then

c...           loop over points in v direction
                     do jgauss = 1, NGAUSS

                        e = (nk-R-1)*(NCP-Q)*(MCP-P)+(nj-Q-1)*(MCP-P)
               

c...                 loop over knot spans in u
                        do ni = P+1, MCP
                           e = e + 1

                           if (U_knot(ni).ne.U_KNOT(ni+1)) then

c...     loop over points in u direction
                              do igauss = 1, NGAUSS
                        
                                 icount = icount + 1   
           

c
c...  Begin calculating stress
c

 
            
c...  Set up element parameters
                                 Emod = EY(e)
                                 numod = NU(e)
            
                                 lambda = numod*Emod/((1d+0+numod)*
     &                                (1d+0-2d+0*numod))
                                 mu = Emod/(2d+0*(1d+0+numod))
            

                  
c...  Get Element Shape functions and their gradients
                  
                                 shl = 0d+0 ! initialize
                                 shg = 0d+0
                                 shgradl = 0d+0
                                 shgradg = 0d+0
                  
                        
                  
                                 call eval_SHAPE_3D(e, gp(igauss), 
     &                                gp(jgauss), gp(kgauss), shl, 
     &                                shgradl, shgradg)
                                 shg = shl
                  
                  
                                 do i = 1,NSHL
                                    yl(i, :) = yg(IEN(e,i),:)
                                 enddo
                  
                                 call e3Strss_3d(e, yl, shg, shgradg, 
     &                                lambda, mu, icount)

                                                     
                              enddo
                           endif
                        enddo
                     enddo
                  endif
               enddo  
            enddo
         endif
      enddo                
     
             
      do i = 1, icount
         do j = 1, 12
            if (j < 12) then
               write (strss_file,"(F15.6)", ADVANCE = "NO")
     &              ElmStrss(i,j)
            else
               write (strss_file,"(F15.6)", ADVANCE = "YES")
     &              ElmStrss(i,j)
            endif
         enddo
      enddo
      
      
      return
      end
