import numpy as np
import datetime
import re
#import shlex, subprocess
from igakit.nurbs import NURBS
from igakit.plot import plt
import math
from igakit.cad import *
from igakit.io import PetIGA,VTK

import sys
"""try:
    backend = sys.argv[1]
    plt.use(backend)
except IndexError:
    pass"""

C = np.zeros((3,3,3,3))

C=[[[[0,0,0],[0,0,1]],[[0,1,0],[0,1,1]]],[
[[1,0,0],[1,0,1]],[[1,1,0],[1,1,1]]]]

umax=0
wmax=0
rmax=0

t = datetime.datetime.now()
t=t.strftime('%Y-%m-%d %H:%M')

actual_path = sys.argv[1] + "/"

namenurbs = sys.argv[2]

with open(actual_path+'controlpoints-radial.csv') as f:
	linea=f.readline()
	for line in f:
		#print line
		list=re.findall("([0123456789.\-Ee]+)",line)
		u=int(float(list[0]))
		w=int(float(list[1]))
		r=int(float(list[2]))
		umax=max(u,umax)
		wmax=max(w,wmax)
		rmax=max(r,rmax)

V = [0, 0, 1, 1]
U = [0, 0, 1, 1]
W = [0, 0, 1, 1]
srf = NURBS([U,V,W], C)
srf=refine(srf,factor=[umax,wmax,rmax-1], degree=2)

#print srf.control.shape
#print umax
#print wmax
#print rmax
		
with open(actual_path+'controlpoints-radial.csv') as f:
	linea=f.readline()
	for line in f:
		#print line
		list=re.findall("([0123456789.\-Ee]+)",line)
		u=int(float(list[0]))
		w=int(float(list[1]))
		r=int(float(list[2]))
		x=float(list[3])
		y=float(list[4])
		z=float(list[5])
		srf.control[u][w][r][0]=x
		srf.control[u][w][r][1]=y
		srf.control[u][w][r][2]=z
          
srf.control[umax+1,:,:,:]=srf.control[0,:,:,:]
srf.control[:,wmax+1,:,:]=srf.control[:,0,:,:]

with open(actual_path+namenurbs ,'w') as g:
	print 'saved to nurbs'
	g.write("3\n")
	g.write("2 2 2\n")
	g.write("%d %d %d\n" % (umax+2,wmax+2,rmax+1))
	for elem in srf.knots[0]:
		g.write("% 13.9f" % elem)
	g.write("\n")
	for elem in srf.knots[1]:
		g.write("% 13.9f" % elem)
	g.write("\n")
	for elem in srf.knots[2]:
		g.write("% 13.9f" % elem)
	g.write("\n")
	#g.write("%f\n" % " ".join(map(str,srf.knots[0])))
	#g.write("%f\n" % " ".join(map(str,srf.knots[1])))
	#g.write("%f\n" % " ".join(map(str,srf.knots[2])))
	for k in range(0,rmax+1):
		for j in range(0,wmax+2):
			for i in range(0,umax+2):
				#g.write(("%13.9f" % strsrf.control[i][j][k][0]).
				g.write("% 16.9f% 16.9f% 16.9f% 16.9f\n" % (srf.control[i][j][k][0],srf.control[i][j][k][1],srf.control[i][j][k][2],1.0))
	
g.close()


#print srf.knots[1]

##Draw
#plt.figure(bgcolor=(1,1,1))
#plt.cplot(srf)
##plt.kplot(srf)
#plt.plot(srf)
#plt.show()


#PetIGA().write("quarter_annulus.dat",srf)
#nrb = PetIGA().read("quarter_annulus.dat")
#VTK().write("nurbsOutput.vtk",       # output filename
            #nrb,                    # igakit NURBS object
            #)
            
sys.exit()

