#!/usr/bin/env python
#coding=utf-8
from __future__ import print_function
import gi
import subprocess
import commands
import threading
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk
from gi.repository import GObject
import os
import re
from shutil import copyfile

#Manejador de los eventos de la interfaz
class Handler:
	#Manejador del evento de click de ejecución
	def on_executeButton_clicked(self, *args):
		#Cargamos todos los elementos de pantalla
		spinner = builder.get_object("spinnerExecuting")
		filechooserbutton = builder.get_object("fileChooserButton")
		#Comprobamos que todos estén correctos, si no lo están lanzamos error, si lo están se ejecuta todo
		try:
			if(isPly()):
				coordyf = float(coordYEntry.get_text())
				coordzf = float(coordZEntry.get_text())
				antitoleranciaf = float(antitoleranciaEntry.get_text())
			tamXi = int(tamXEntry.get_text())
			tamYi = int(tamYEntry.get_text())
			tamZi = int(tamZEntry.get_text())
			if(checkGeneral.get_active()):
				pauxx = int(ppXEntry.get_text())
				pauxy = int(ppYEntry.get_text())
				pauxz = int(ppZEntry.get_text())
				nauxx = int(neXEntry.get_text())
				nauxy = int(neYEntry.get_text())
				nauxz = int(neZEntry.get_text())
				int(pfXEntry.get_text())
				int(pfYEntry.get_text())
				int(pfZEntry.get_text())
				int(oXEntry.get_text())
				int(oYEntry.get_text())
				int(oZEntry.get_text())
				int(iUEntry.get_text()+"1") #truco para comprobar un guion
				int(iVEntry.get_text()+"1")
				int(iWEntry.get_text()+"1")
				int(rXEntry.get_text())
				int(rYEntry.get_text())
				int(rZEntry.get_text())
				if((nauxx % pauxx)!=0 or (nauxy % pauxy)!=0 or (nauxz % pauxz)!=0):
					raise ValueError('Error with divisible sizes in general') 
			if(checkPetiga.get_active()):
				rauxx = int(rmsXEntry.get_text())
				rauxy = int(rmsYEntry.get_text())
				rauxz = int(rmsZEntry.get_text())
				if((rauxx % tamXi)!=0 or (rauxy % tamYi)!=0 or (rauxz % tamZi)!=0):
					raise ValueError('Error with divisible sizes in petiga') 
			patron = re.compile("^[A-Za-z0-9_-]+$");
			if(os.path.exists(nameEntry.get_text()) or nameEntry.get_text()=='' or (not patron.match(nameEntry.get_text()))):
				dialog = Gtk.MessageDialog(window, 0, Gtk.MessageType.WARNING,Gtk.ButtonsType.OK, "Wrong name")
				dialog.format_secondary_text("Simulation name is in use or is not correct, please select a different name.")
				dialog.run()
				dialog.destroy()
			else:
				if(filechooser.get_filename()=="" or filechooser.get_filename()==None):
					dialog = Gtk.MessageDialog(window, 0, Gtk.MessageType.WARNING,Gtk.ButtonsType.OK, "Error with file")
					dialog.format_secondary_text("Please, insert a correct file.")
					dialog.run()
					dialog.destroy()
				else:
					print("Creating directory structure..")
					os.mkdir(nameEntry.get_text())
					os.mkdir(nameEntry.get_text()+"/iteracion_centro")
					print("Directory structure created")
					#Función de ejecutar
					init_exec(spinner, endExec)
		except ValueError:
			dialog = Gtk.MessageDialog(window, 0, Gtk.MessageType.WARNING,Gtk.ButtonsType.OK, "The entered data is not correct")
			dialog.format_secondary_text("Please enter the data correctly. \nRemember to use dots to indicate decimals and do not enter strange letters or symbols.")
			dialog.run()
			dialog.destroy()
	#Manejador del evento de mostrar opciones
	def on_butSetGeneralOptions_clicked(self, *args):
		
		def on_exitoptions_click(self, *args):
			ppXEntry.set_text("")
			ppYEntry.set_text("")
			ppZEntry.set_text("")
			neXEntry.set_text("")
			neYEntry.set_text("")
			neZEntry.set_text("")
			pfXEntry.set_text("1")
			pfYEntry.set_text("0")
			pfZEntry.set_text("1")
			oXEntry.set_text("2")
			oYEntry.set_text("2")
			oZEntry.set_text("2")
			iUEntry.set_text("-")
			iVEntry.set_text("-")
			iWEntry.set_text("-")
			rXEntry.set_text("-1")
			rYEntry.set_text("-1")
			rZEntry.set_text("-1")
			window2.hide()
			return True
		window2.connect("delete-event", on_exitoptions_click)
		window2.set_position(Gtk.WindowPosition.CENTER)
		window2.set_title("General Options")
		window2.show_all()
	
	#Manejador del evento de aceptar opciones generales
	def on_buttAcceptOptionsAutomesh_clicked(self, *args):
		window2.hide()
		
	#Manejador del evento de mostrar opciones
	def on_butSetPetigaOptions_clicked(self, *args):
		
		def on_exitoptions_click(self, *args):
			rmsXEntry.set_text("")
			rmsYEntry.set_text("")
			rmsZEntry.set_text("")
			window3.hide()
			return True
		window3.connect("delete-event", on_exitoptions_click)
		window3.set_position(Gtk.WindowPosition.CENTER)
		window3.set_title("Petiga Options")
		window3.show_all()
	
	#Manejador del evento aceptar opciones petiga
	def on_buttAcceptOptionsPetiga_clicked(self, *args):
		window3.hide()
		
	#Manejador del modo PLY
	def on_radiobuttonply_toggled(self, *args):
		if radiobuttonply.get_active():
			set_ply_mode()
	
	#Manejador del modo NURBS
	def on_radiobuttonnurbs_toggled(self, *args):
		if radiobuttonnurbs.get_active():
			set_nurbs_mode()
	


#Ejecutar un comando y obtener su lista de salidas
def execute(cmd):
	popen = subprocess.Popen(cmd, stdout=subprocess.PIPE, universal_newlines=True)
	for stdout_line in iter(popen.stdout.readline, ""):
		yield stdout_line 
	popen.stdout.close()
	return_code = popen.wait()
	if return_code:
		raise subprocess.CalledProcessError(return_code, cmd)

#Callback de acabar las ejecuciones
def endExec(res):
	#Captura de códigos de error generados para información un poco más clara
	if res==0:
		dialog = Gtk.MessageDialog(window, 0, Gtk.MessageType.INFO,Gtk.ButtonsType.OK, "Execution of " + nameEntry.get_text() + " is finished")
		dialog.format_secondary_text("Thank you very much for your patience. Execution completed successfully.")
		dialog.run()
		dialog.destroy()
	elif res==1:
		dialog = Gtk.MessageDialog(window, 0, Gtk.MessageType.ERROR,Gtk.ButtonsType.OK, "Unfortunately, an error has occurred.")
		dialog.format_secondary_text("An error has occurred in the execution of \"mallador\". Please review the data and try again.")
		dialog.run()
		dialog.destroy()
	elif res==2:
		dialog = Gtk.MessageDialog(window, 0, Gtk.MessageType.ERROR,Gtk.ButtonsType.OK, "Unfortunately, an error has occurred.")
		dialog.format_secondary_text("An error has occurred in the execution of \"generarNurbs\". Please review the data and try again.")
		dialog.run()
		dialog.destroy()
	elif res==3:
		dialog = Gtk.MessageDialog(window, 0, Gtk.MessageType.ERROR,Gtk.ButtonsType.OK, "Unfortunately, an error has occurred.")
		dialog.format_secondary_text("An error has occurred in the execution of \"genanillo\". Please review the data and try again.")
		dialog.run()
		dialog.destroy()
	elif res==4:
		dialog = Gtk.MessageDialog(window, 0, Gtk.MessageType.ERROR,Gtk.ButtonsType.OK, "Unfortunately, an error has occurred.")
		dialog.format_secondary_text("An error has occurred in the execution of \"generadorgeneral\". Please review the data and try again.")
		dialog.run()
		dialog.destroy()
	else:
		dialog = Gtk.MessageDialog(window, 0, Gtk.MessageType.ERROR,Gtk.ButtonsType.OK, "Unfortunately, an error has occurred.")
		dialog.format_secondary_text("An Unknown error has occurred. Please review the data and try again.")
		dialog.run()
		dialog.destroy()
	    
#Función asíncrona para ejecución de animaciones
def init_exec(spinner, finishcb):
		#Iniciamos las animaciones
		spinner.start()
		button.set_label("Running")
		enable_options(False)
		#Función que ejecuta el thread
		def thread_run():
			heavy_ret = execute_system()
			GObject.idle_add(cleanup, heavy_ret)
		#Callback de limpieza para cuando el thread termine
		def cleanup(heavy_ret):
			executing = 0
			spinner.stop()
			button.set_label("Run")
			enable_options(True)
			t.join()
			finishcb(heavy_ret)
		#Inicio de función
		t = threading.Thread(target=thread_run)
		t.start()
    
#Función que realiza la ejecución de los programas
def execute_system():
	#Función de ejecución de todos los sistemas
	tamZ = builder.get_object("tamZEntry")
	namenurbs = "nurbs_"+coordYEntry.get_text()+"_"+coordZEntry.get_text()+"_"+antitoleranciaEntry.get_text()+"_"+tamYEntry.get_text()+"x"+tamZEntry.get_text()+"x"+tamXEntry.get_text();
	#Comprobar si es un ply o un nurbs
	if isPly():
		#Mallador
		try:
			for outUl in execute(["./Mallador", filechooser.get_filename(), coordYEntry.get_text(), coordZEntry.get_text(), antitoleranciaEntry.get_text(), tamXEntry.get_text(), tamYEntry.get_text(), tamZEntry.get_text(), nameEntry.get_text()]):
					print(outUl, end="")
		except:
			return 1 #Error mallador
		#Generar Nurbs
		try:
			for outUl in execute(["python", "generarNurbsInterfaz.py", nameEntry.get_text(), namenurbs]):
					print(outUl, end="")	
		except:
			return 2 #Error generar Nurbs
	else:
		namenurbs="nurbs"
		copyfile(filechooser.get_filename(), nameEntry.get_text()+"/"+namenurbs)
	if(checkPetiga.get_active()):
		#Generar anillo
		try:
			auxX = int(rmsXEntry.get_text())/int(tamXEntry.get_text())
			auxY = int(rmsYEntry.get_text())/int(tamYEntry.get_text())
			auxZ = int(rmsZEntry.get_text())/int(tamZEntry.get_text())
			for outUl in execute(["python", "genanilloInterfaz.py", nameEntry.get_text(), namenurbs, str(auxX), str(auxY), str(auxZ), str(reCheckC.get_active()), str(reCheckR.get_active()), str(reCheckT.get_active())]):
					print(outUl, end="")
					#Detallar más los errores
			for outUl in execute(["python", "anilloplotInterfaz.py", nameEntry.get_text()]):
					print(outUl, end="")
		except:
			return 3 #Error generar anillo
	if(checkGeneral.get_active()):
		#Generar general
		try:
			for outUl in execute(["./automeshInterfaz.sh", nameEntry.get_text(), "99", ppXEntry.get_text(), ppYEntry.get_text(), ppZEntry.get_text(), 
			neXEntry.get_text(), neYEntry.get_text(), neZEntry.get_text(), pfXEntry.get_text(), pfYEntry.get_text(), pfZEntry.get_text(),
			oXEntry.get_text(), oYEntry.get_text(), oZEntry.get_text(), iUEntry.get_text(), iVEntry.get_text(), iWEntry.get_text(),
			rXEntry.get_text(), rYEntry.get_text(), rZEntry.get_text(), namenurbs]):
					print(outUl, end="")
		except:
			return 4 #Error generar general
	return 0
	
#Activa o desactiva los cuadros de texto y el botón
def enable_options(active):
	coordYEntry.set_sensitive(active and isPly())
	coordZEntry.set_sensitive(active and isPly())
	antitoleranciaEntry.set_sensitive(active and isPly())
	filechooser.set_sensitive(active)
	tamXEntry.set_sensitive(active)
	tamYEntry.set_sensitive(active)
	tamZEntry.set_sensitive(active)
	nameEntry.set_sensitive(active)
	checkPetiga.set_sensitive(active)
	checkGeneral.set_sensitive(active)
	butSetGeneralOptions.set_sensitive(active)
	butSetPetigaOptions.set_sensitive(active)
	radiobuttonply.set_sensitive(active)
	radiobuttonnurbs.set_sensitive(active)
	button.set_sensitive(active)
	
#Carga el archivo de glade
builder = Gtk.Builder()
builder.add_from_file("interfazproyecto.glade")
#Conecta los handlers para la plantilla
builder.connect_signals(Handler())

#Variables de las entradas de opciones
coordYEntry = builder.get_object("coordYEntry")
coordZEntry = builder.get_object("coordZEntry")
antitoleranciaEntry = builder.get_object("antitoleranciaEntry")
antitoleranciaEntry.set_text("7.5")
tamXEntry = builder.get_object("tamXEntry")
tamXEntry.set_text("32")
tamYEntry = builder.get_object("tamYEntry")
tamYEntry.set_text("32")
tamZEntry = builder.get_object("tamZEntry")
tamZEntry.set_text("8")
nameEntry = builder.get_object("nameEntry")
checkPetiga = builder.get_object("checkPetiga")
checkPetiga.set_active(True)
checkGeneral = builder.get_object("checkGeneral")
checkGeneral.set_active(True)
butSetGeneralOptions = builder.get_object("butSetGeneralOptions")
butSetPetigaOptions = builder.get_object("butSetPetigaOptions")
radiobuttonply = builder.get_object("radiobuttonply")
radiobuttonnurbs = builder.get_object("radiobuttonnurbs")


ppXEntry = builder.get_object("ppXEntry")
ppYEntry = builder.get_object("ppYEntry")
ppZEntry = builder.get_object("ppZEntry")
neXEntry = builder.get_object("neXEntry")
neYEntry = builder.get_object("neYEntry")
neZEntry = builder.get_object("neZEntry")
pfXEntry = builder.get_object("pfXEntry")
pfXEntry.set_text("1")
pfYEntry = builder.get_object("pfYEntry")
pfYEntry.set_text("0")
pfZEntry = builder.get_object("pfZEntry")
pfZEntry.set_text("1")
oXEntry = builder.get_object("oXEntry")
oXEntry.set_text("2")
oYEntry = builder.get_object("oYEntry")
oYEntry.set_text("2")
oZEntry = builder.get_object("oZEntry")
oZEntry.set_text("2")
iUEntry = builder.get_object("iUEntry")
iUEntry.set_text("-")
iVEntry = builder.get_object("iVEntry")
iVEntry.set_text("-")
iWEntry = builder.get_object("iWEntry")
iWEntry.set_text("-")
rXEntry = builder.get_object("rXEntry")
rXEntry.set_text("-1")
rYEntry = builder.get_object("rYEntry")
rYEntry.set_text("-1")
rZEntry = builder.get_object("rZEntry")
rZEntry.set_text("-1")
rmsXEntry = builder.get_object("rmsXEntry")
rmsYEntry = builder.get_object("rmsYEntry")
rmsZEntry = builder.get_object("rmsZEntry")
reCheckC = builder.get_object("reCheckC")
reCheckR = builder.get_object("reCheckR")
reCheckT = builder.get_object("reCheckT")
reCheckT.set_active(True)


#Filtros para archivos
filterply = Gtk.FileFilter()
filterply.add_pattern("*.ply")
filternurbs = Gtk.FileFilter()
filternurbs.add_pattern("nurbs*")
filechooser = builder.get_object("fileChooserButton")
filechooser.set_filter(filterply)

#Comprobacion si estamos en el modo ply
def isPly():
	return radiobuttonply.get_active()

#Establecer el modo nurbs en la aplicacion
def set_nurbs_mode():
	filechooser.set_filter(filternurbs)
	coordYEntry.set_sensitive(isPly())
	coordZEntry.set_sensitive(isPly())
	antitoleranciaEntry.set_sensitive(isPly())
	builder.get_object("labelfile").set_text("Nurbs file:")
	filechooser.unselect_all()
	
#Establecer el modo ply en la aplicacion
def set_ply_mode():
	filechooser.set_filter(filterply)
	coordYEntry.set_sensitive(isPly())
	coordZEntry.set_sensitive(isPly())
	antitoleranciaEntry.set_sensitive(isPly())
	builder.get_object("labelfile").set_text("Surface file:")
	filechooser.unselect_all()

#Establecer la cadena de tabulaciones manualmente
builder.get_object("grid1").set_focus_chain([nameEntry, radiobuttonply, radiobuttonnurbs, filechooser,
tamYEntry,tamZEntry, tamXEntry,  coordYEntry, coordZEntry,
antitoleranciaEntry, checkPetiga,butSetPetigaOptions, checkGeneral, butSetGeneralOptions,
builder.get_object("executeButton")])

#Activa las ventanas
button = builder.get_object("executeButton")
window = builder.get_object("window1")
window2 = builder.get_object("windowopt")
window3 = builder.get_object("windowoptpetiga")
window.connect("delete-event", Gtk.main_quit)
window.set_position(Gtk.WindowPosition.CENTER)
window.set_title("PROMISE | Prostate Meshes for Isogeometric Analysis")
window.set_icon_from_file("icon.png")
window.show_all()

Gtk.main()
